Subject: Re: [PATCH] s2io: add PCI error recovery support

From: [email-masked] (Linas Vepstas)
Date: Wed, 25 Oct 2006 10:11:24 -0500

On Wed, Oct 25, 2006 at 02:29:33AM -0400, Ananda Raju wrote:
> Hi, 
> 
> s2io_card_down() will do few BAR0 read/write. As per
> pci-error-recovery.txt Documentation we are not supposed to do any new
> IO in error_detected(). 

Hmm, actually, its harmless to do further i/o. The s2io driver barks
(as it should) because the result of reads is always 0xffffffff.

> Can you try using 
> 
> atomic_set(&sp->card_state, CARD_DOWN); 
> 
> instead of s2io_card_down().

I will try that. I was mostly concerned that s2io_card_down()
also may do some other "important" things with regards to the driver
state, things which might be needed to keep the down-up sequence
symmetrical. I wasn't sure, so I took the conservative route.

> Also we have to add following if statement in beginning of s2io_isr().
> 
> if (atomic_read(&nic->card_state) == CARD_DOWN)
> 	return IRQ_NOTHANDLED.

Right! Will revise this patch shortly.

> If it is ok to do BAR0 read/write in error_detected() then patch is OK. 

Its OK on pSeries, and I beleive it will be OK on PCIE, but I do
not quite know enough about actual PCIE chipsets.

--linas